diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/wraparound-model.cc ns-3.46/src/spectrum/model/wraparound-model.cc
--- ns-3.45/src/spectrum/model/wraparound-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/spectrum/model/wraparound-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2025 CTTC
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+ */
+
+#include "wraparound-model.h"
+
+#include "ns3/log.h"
+#include "ns3/mobility-building-info.h"
+#include "ns3/node.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("WraparoundModel");
+NS_OBJECT_ENSURE_REGISTERED(WraparoundModel);
+
+TypeId
+WraparoundModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::WraparoundModel")
+                            .SetParent<Object>()
+                            .SetGroupName("Spectrum")
+                            .AddConstructor<WraparoundModel>();
+    return tid;
+}
+
+Ptr<MobilityModel>
+WraparoundModel::GetVirtualMobilityModel(Ptr<const MobilityModel> tx,
+                                         Ptr<const MobilityModel> rx) const
+{
+    NS_LOG_DEBUG("Transmitter using virtual mobility model. Real position "
+                 << tx->GetPosition() << ", receiver position " << rx->GetPosition()
+                 << ", wrapped position "
+                 << GetVirtualPosition(tx->GetPosition(), rx->GetPosition()) << ".");
+    auto virtualMm = tx->Copy();
+    // Set the transmitter to its virtual position respective to receiver
+    virtualMm->SetPosition(GetVirtualPosition(tx->GetPosition(), rx->GetPosition()));
+
+    // Unidirectionally aggregate NodeId to it, so it can be fetched later by
+    // propagation models
+    auto node = tx->GetObject<Node>();
+    if (node)
+    {
+        virtualMm->UnidirectionalAggregateObject(node);
+    }
+
+    // Some mobility models access building info related to mobility model
+    auto mbi = tx->GetObject<MobilityBuildingInfo>();
+    if (mbi)
+    {
+        virtualMm->UnidirectionalAggregateObject(mbi);
+    }
+    return virtualMm;
+}
+
+Vector3D
+WraparoundModel::GetVirtualPosition(const Vector3D tx, const Vector3D rx) const
+{
+    return tx; // Placeholder, you are supposed to implement whatever wraparound model you want
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/wraparound-model.h ns-3.46/src/spectrum/model/wraparound-model.h
--- ns-3.45/src/spectrum/model/wraparound-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/spectrum/model/wraparound-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2025 CTTC
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+ */
+
+#ifndef WRAPAROUNDMODEL_H
+#define WRAPAROUNDMODEL_H
+
+#include "ns3/mobility-model.h"
+
+namespace ns3
+{
+class WraparoundModel : public Object
+{
+  public:
+    /**
+     * @brief Default constructor
+     */
+    WraparoundModel() = default;
+
+    /**
+     * Register this type with the TypeId system.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * @brief Creates a disposable virtual mobility model for tx based on rx distance and
+     * a wraparound model
+     * @param tx Transmitter mobility model
+     * @param rx Receiver Mobility model
+     * @return virtual mobility model for transmitter
+     */
+    Ptr<MobilityModel> GetVirtualMobilityModel(Ptr<const MobilityModel> tx,
+                                               Ptr<const MobilityModel> rx) const;
+    /**
+     * @brief Get virtual position of txPos with respect to rxPos. Each wraparound model
+     * should override this function with their own implementation
+     * @param tx Transmitter position
+     * @param rx Receiver position
+     * @return virtual position of transmitter in respect to receiver position
+     */
+    virtual Vector3D GetVirtualPosition(const Vector3D tx, const Vector3D rx) const;
+};
+} // namespace ns3
+
+#endif // WRAPAROUNDMODEL_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/test/spectrum-value-test.cc ns-3.46/src/spectrum/test/spectrum-value-test.cc
--- ns-3.45/src/spectrum/test/spectrum-value-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/spectrum/test/spectrum-value-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -6,11 +6,10 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include "spectrum-test.h"
-
 #include "ns3/log.h"
 #include "ns3/object.h"
 #include "ns3/spectrum-converter.h"
+#include "ns3/spectrum-test.h"
 #include "ns3/spectrum-value.h"
 #include "ns3/test.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/test/wraparound-model-test.cc ns-3.46/src/spectrum/test/wraparound-model-test.cc
--- ns-3.45/src/spectrum/test/wraparound-model-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/spectrum/test/wraparound-model-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,257 @@
+/*
+ * Copyright (c) 2025 CTTC
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+ */
+
+#include "ns3/boolean.h"
+#include "ns3/config.h"
+#include "ns3/hexagonal-wraparound-model.h"
+#include "ns3/mobility-helper.h"
+#include "ns3/node-container.h"
+#include "ns3/simulator.h"
+#include "ns3/test.h"
+#include "ns3/waypoint-mobility-model.h"
+
+using namespace ns3;
+
+/**
+ * @ingroup propagation-test
+ *
+ * @brief Wraparound Model Test
+ */
+class WraparoundModelTest : public TestCase
+{
+  public:
+    /**
+     * Constructor for test case
+     * @param name description of test case
+     * @param numRings number of rings used in the deployment
+     * @param alternativeConfig wraparound is configured manually when false, or via constructor
+     * when true.
+     */
+    WraparoundModelTest(std::string name, int numRings, bool alternativeConfig)
+        : TestCase(name),
+          m_numRings(numRings),
+          m_alternativeConfig(alternativeConfig)
+    {
+    }
+
+  private:
+    int m_numRings;           ///< number of wrings to wraparound
+    bool m_alternativeConfig; ///< indicate whether to configure isd and numSites via constructor or
+                              ///< manually
+  private:
+    void DoRun() override;
+};
+
+size_t
+GetNearestSite(std::vector<Vector3D>& sites, size_t numSites, Vector3D virtualPos)
+{
+    double minDist = std::numeric_limits<double>::max();
+    size_t minSite = 0;
+    for (size_t siteI = 0; siteI < sites.size() && siteI < numSites; siteI++)
+    {
+        auto dist = CalculateDistance(sites.at(siteI), virtualPos);
+        if (dist < minDist)
+        {
+            minDist = dist;
+            minSite = siteI;
+        }
+    }
+    return minSite;
+}
+
+void
+WraparoundModelTest::DoRun()
+{
+    int numSites = 0;
+    switch (m_numRings)
+    {
+    case 0:
+        numSites = 1;
+        break;
+    case 1:
+        numSites = 7;
+        break;
+    case 3:
+        numSites = 19;
+        break;
+    default:
+        NS_TEST_EXPECT_MSG_EQ(false,
+                              true,
+                              "Wraparound does not support " << m_numRings << " rings");
+        break;
+    }
+
+    NodeContainer userNodes(1);
+    NodeContainer siteNodes(numSites);
+
+    MobilityHelper mobilityHelper;
+    mobilityHelper.SetMobilityModel("ns3::ConstantPositionMobilityModel");
+
+    // Site positions
+    // clang-format off
+    std::vector<Vector3D> sitePositions = {
+        Vector3D(    0,     0, 30), // Site 01
+        Vector3D( 1000,     0, 30), // Site 02
+        Vector3D(  500,   866, 30), // Site 03
+        Vector3D( -500,   866, 30), // Site 04
+        Vector3D(-1000,     0, 30), // Site 05
+        Vector3D( -500,  -866, 30), // Site 06
+        Vector3D(  500,  -866, 30), // Site 07
+        Vector3D( 2000,     0, 30), // Site 08
+        Vector3D( 1500,   866, 30), // Site 09
+        Vector3D(  500,  1732, 30), // Site 10
+        Vector3D( -500,  1732, 30), // Site 11
+        Vector3D(-1500,   866, 30), // Site 12
+        Vector3D(-2000,     0, 30), // Site 13
+        Vector3D(-1500,  -866, 30), // Site 14
+        Vector3D( -500, -1732, 30), // Site 15
+        Vector3D(  500, -1732, 30), // Site 16
+        Vector3D( 1500,  -866, 30), // Site 17
+        Vector3D( 1000,  1732, 30), // Site 18
+        Vector3D(-1000,  1732, 30), // Site 19
+    };
+    // clang-format on
+
+    Ptr<HexagonalWraparoundModel> wraparoundModel =
+        m_alternativeConfig ? CreateObject<HexagonalWraparoundModel>()
+                            : CreateObject<HexagonalWraparoundModel>(1000, numSites);
+
+    if (m_alternativeConfig)
+    {
+        wraparoundModel->SetSiteDistance(1000);
+        wraparoundModel->SetNumSites(numSites);
+        auto sitePositionsSlice =
+            std::vector<Vector3D>(sitePositions.begin(), sitePositions.begin() + numSites);
+        wraparoundModel->SetSitePositions(sitePositionsSlice);
+    }
+
+    // Install mobility models
+    mobilityHelper.Install(userNodes);
+    mobilityHelper.Install(siteNodes);
+
+    // Add site positions and wraparound model
+    for (auto i = 0; i < numSites; i++)
+    {
+        auto siteMm = siteNodes.Get(i)->GetObject<MobilityModel>();
+        siteMm->SetPosition(sitePositions.at(i));
+        if (!m_alternativeConfig)
+        {
+            wraparoundModel->AddSitePosition(sitePositions.at(i));
+        }
+    }
+
+    // Retrieve user node mobility to move it around
+    auto userMm = userNodes.Get(0)->GetObject<MobilityModel>();
+
+    // Test cases (target site number, expected UE virtual site, real user position, expected
+    // wrapped position)
+    std::vector<std::tuple<size_t, size_t, Vector3D, Vector3D>> testPoint;
+    // clang-format off
+    switch (m_numRings)
+    {
+    case 3: // Cases involving sites 8-19
+        testPoint.emplace_back( 7,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back( 8,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back( 9,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(10,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(11,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(12,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(13,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(14,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(15,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(16,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(17,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(18,  0, Vector3D(    0,     0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back( 7,  0, Vector3D(  100,     0, 0), Vector3D(  100,     0, 0));
+        testPoint.emplace_back( 8,  0, Vector3D(  500,     0, 0), Vector3D(  500,     0, 0));
+        testPoint.emplace_back( 9,  1, Vector3D( 1000,     0, 0), Vector3D( 1000,     0, 0));
+        testPoint.emplace_back(10,  2, Vector3D( 1000,  1000, 0), Vector3D( 1000,  1000, 0));
+        testPoint.emplace_back(11,  0, Vector3D( -500,     0, 0), Vector3D( -500,     0, 0));
+        testPoint.emplace_back(12,  0, Vector3D(    0,  -500, 0), Vector3D(    0,  -500, 0));
+        testPoint.emplace_back(13,  5, Vector3D(-1000, -1000, 0), Vector3D(-1000, -1000, 0));
+        testPoint.emplace_back(14, 13, Vector3D( 2000, -1000, 0), Vector3D(-2330, -1500, 0));
+        testPoint.emplace_back(15, 16, Vector3D(-1000,  2000, 0), Vector3D( 1598, -1500, 0));
+        testPoint.emplace_back(16, 15, Vector3D( 2000,  2000, 0), Vector3D(  267, -2000, 0));
+        testPoint.emplace_back(17, 10, Vector3D(-2000, -2000, 0), Vector3D( -268,  2000, 0));
+        testPoint.emplace_back(18, 11, Vector3D(-2000,  1500, 0), Vector3D(-2000,  1500, 0));
+        break;
+    case 1: // Cases involving sites 2-7
+        testPoint.emplace_back(1, 0, Vector3D(    0,    0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(2, 0, Vector3D(    0,    0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(3, 0, Vector3D(    0,    0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(4, 0, Vector3D(    0,    0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(5, 0, Vector3D(    0,    0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(6, 0, Vector3D(    0,    0, 0), Vector3D(    0,     0, 0));
+        testPoint.emplace_back(1, 1, Vector3D( 1000,    0, 0), Vector3D( 1000,     0, 0));
+        testPoint.emplace_back(2, 3, Vector3D( 1000, -500, 0), Vector3D( -732,  1500, 0));
+        testPoint.emplace_back(3, 4, Vector3D( 1000,  500, 0), Vector3D(-1598,     0, 0));
+        testPoint.emplace_back(4, 4, Vector3D(-1000,    0, 0), Vector3D(-1000,     0, 0));
+        testPoint.emplace_back(5, 6, Vector3D(-1000,  500, 0), Vector3D(  732, -1500, 0));
+        testPoint.emplace_back(6, 1, Vector3D(-1000, -500, 0), Vector3D( 1598,     0, 0));
+        break;
+    case 0: // Cases involving site 1. No wraparound.
+        testPoint.emplace_back(0, 0, Vector3D(    0,     0, 0), Vector3D(   0,      0, 0));
+        testPoint.emplace_back(0, 0, Vector3D( 1000,  1000, 0), Vector3D( 1000,  1000, 0));
+        testPoint.emplace_back(0, 0, Vector3D( 1000, -1000, 0), Vector3D( 1000, -1000, 0));
+        testPoint.emplace_back(0, 0, Vector3D(-1000,  1000, 0), Vector3D(-1000,  1000, 0));
+        testPoint.emplace_back(0, 0, Vector3D(-1000, -1000, 0), Vector3D(-1000, -1000, 0));
+        testPoint.emplace_back(0, 0, Vector3D( 2000,  2000, 0), Vector3D( 2000,  2000, 0));
+        testPoint.emplace_back(0, 0, Vector3D( 2000, -2000, 0), Vector3D( 2000, -2000, 0));
+        testPoint.emplace_back(0, 0, Vector3D(-2000,  2000, 0), Vector3D(-2000,  2000, 0));
+        testPoint.emplace_back(0, 0, Vector3D(-2000, -2000, 0), Vector3D(-2000, -2000, 0));
+    default:
+        break;
+    }
+    // clang-format on
+
+    for (auto [siteNumber, expectedVirtualUserSite, realUserPos, expectedVirtualPos] : testPoint)
+    {
+        userMm->SetPosition(realUserPos);
+        auto siteMm = siteNodes.Get(siteNumber)->GetObject<MobilityModel>();
+        auto virtualPos =
+            wraparoundModel->GetVirtualPosition(userMm->GetPosition(), siteMm->GetPosition());
+        auto nearestSiteToVirtualUser = GetNearestSite(sitePositions, numSites, virtualPos);
+        NS_TEST_EXPECT_MSG_EQ(nearestSiteToVirtualUser,
+                              expectedVirtualUserSite,
+                              "Virtual position leads to from real site "
+                                  << GetNearestSite(sitePositions, numSites, realUserPos)
+                                  << " to incorrect site " << nearestSiteToVirtualUser);
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(CalculateDistance(virtualPos, expectedVirtualPos),
+                                    5,
+                                    "Expected " << expectedVirtualPos << " and obtained "
+                                                << virtualPos << " virtual positions differ");
+    }
+    // Move user node and check virtual positions correspond to the expected sites
+    Simulator::Stop(MilliSeconds(1));
+    Simulator::Run();
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup propagation-test
+ *
+ * @brief Wraparound Model Test Suite
+ */
+static struct WraparoundModelTestSuite : public TestSuite
+{
+    WraparoundModelTestSuite()
+        : TestSuite("wraparound-model", Type::UNIT)
+    {
+        std::vector<bool> alternativeConfig{false, true};
+        for (auto altConf : alternativeConfig)
+        {
+            // Supported ring numbers
+            AddTestCase(new WraparoundModelTest("Check wraparound with 0 rings", 0, altConf),
+                        TestCase::Duration::QUICK);
+            AddTestCase(new WraparoundModelTest("Check wraparound with 1 rings", 1, altConf),
+                        TestCase::Duration::QUICK);
+            AddTestCase(new WraparoundModelTest("Check wraparound with 3 rings", 3, altConf),
+                        TestCase::Duration::QUICK);
+        }
+    }
+} g_WraparoundModelTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/utils/spectrum-test.h ns-3.46/src/spectrum/utils/spectrum-test.h
--- ns-3.45/src/spectrum/utils/spectrum-test.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/spectrum/utils/spectrum-test.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,151 @@
+/*
+ * Copyright (c) 2009 University of Washington
+ * Copyright (c) 2011 CTTC
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Nicola Baldo <nbaldo@cttc.es>
+ * part of the code copied from test.h
+ */
+
+#ifndef SPECTRUM_TEST_H
+#define SPECTRUM_TEST_H
+
+#include "ns3/spectrum-value.h"
+#include "ns3/test.h"
+
+/**
+ * @ingroup spectrum
+ * @defgroup spectrum-test Spectrum module tests
+ */
+
+/**
+ * @ingroup spectrum-tests
+ *
+ * @brief Test if two SpectrumModel instances are equal within a given tolerance.
+ *
+ * This test compares component-by-component the two SpectrumModel
+ * instances; if any pair of components differs by more than the given
+ * tolerance, the test fails.
+ *
+ * @param actual the actual value obtained by the simulator
+ * @param expected the expected value obtained by off-line calculations
+ * @param tol the tolerance
+ * @param msg the message to print if the test fails
+ *
+ */
+#define NS_TEST_ASSERT_MSG_SPECTRUM_MODEL_EQ_TOL(actual, expected, tol, msg)                       \
+    do                                                                                             \
+    {                                                                                              \
+        auto i = (actual).Begin();                                                                 \
+        auto j = (expected).Begin();                                                               \
+        uint32_t k = 0;                                                                            \
+        while (i != (actual).End() && j != (expected).End())                                       \
+        {                                                                                          \
+            if ((i->fl > j->fl + (tol)) || (i->fl < j->fl - (tol)) || (i->fc > j->fc + (tol)) ||   \
+                (i->fc < j->fc - (tol)) || (i->fh > j->fh + (tol)) || (i->fh < j->fh - (tol)))     \
+            {                                                                                      \
+                ASSERT_ON_FAILURE;                                                                 \
+                std::ostringstream indexStream;                                                    \
+                indexStream << "[" << k << "]";                                                    \
+                std::ostringstream msgStream;                                                      \
+                msgStream << (msg);                                                                \
+                std::ostringstream actualStream;                                                   \
+                actualStream << i->fl << " <-- " << i->fc << " --> " << i->fh;                     \
+                std::ostringstream expectedStream;                                                 \
+                expectedStream << j->fl << " <-- " << j->fc << " --> " << j->fh;                   \
+                ReportTestFailure(std::string(#actual) + indexStream.str() +                       \
+                                      " == " + std::string(#expected) + indexStream.str(),         \
+                                  actualStream.str(),                                              \
+                                  expectedStream.str(),                                            \
+                                  msgStream.str(),                                                 \
+                                  (__FILE__),                                                      \
+                                  (__LINE__));                                                     \
+                CONTINUE_ON_FAILURE;                                                               \
+            }                                                                                      \
+            ++i;                                                                                   \
+            ++j;                                                                                   \
+            ++k;                                                                                   \
+        }                                                                                          \
+        if (i != (actual).End() || j != (expected).End())                                          \
+        {                                                                                          \
+            std::ostringstream msgStream;                                                          \
+            msgStream << (msg);                                                                    \
+            std::ostringstream actualStream;                                                       \
+            actualStream << (i != (actual).End());                                                 \
+            std::ostringstream expectedStream;                                                     \
+            expectedStream << (j != (expected).End());                                             \
+            ReportTestFailure("Bands::iterator == End ()",                                         \
+                              actualStream.str(),                                                  \
+                              expectedStream.str(),                                                \
+                              msgStream.str(),                                                     \
+                              (__FILE__),                                                          \
+                              (__LINE__));                                                         \
+        }                                                                                          \
+    } while (false);
+
+/**
+ * @ingroup spectrum-tests
+ *
+ * @brief Test if two SpectrumValue instances are equal within a given tolerance.
+ *
+ * This test compares component-by-component the two SpectrumValue
+ * instances; if any pair of components differs by more than the given
+ * tolerance, the test fails.
+ *
+ * @param actual the actual value obtained by the simulator
+ * @param expected the expected value obtained by off-line calculations
+ * @param tol the tolerance
+ * @param msg the message to print if the test fails
+ *
+ */
+#define NS_TEST_ASSERT_MSG_SPECTRUM_VALUE_EQ_TOL(actual, expected, tol, msg)                       \
+    do                                                                                             \
+    {                                                                                              \
+        auto i = (actual).ConstValuesBegin();                                                      \
+        auto j = (expected).ConstValuesBegin();                                                    \
+        uint32_t k = 0;                                                                            \
+        while (i != (actual).ConstValuesEnd() && j != (expected).ConstValuesEnd())                 \
+        {                                                                                          \
+            if ((*i) > (*j) + (tol) || (*i) < (*j) - (tol))                                        \
+            {                                                                                      \
+                ASSERT_ON_FAILURE;                                                                 \
+                std::ostringstream indexStream;                                                    \
+                indexStream << "[" << k << "]";                                                    \
+                std::ostringstream msgStream;                                                      \
+                msgStream << msg;                                                                  \
+                std::ostringstream actualStream;                                                   \
+                actualStream << actual;                                                            \
+                std::ostringstream expectedStream;                                                 \
+                expectedStream << expected;                                                        \
+                ReportTestFailure(std::string(#actual) + indexStream.str() +                       \
+                                      " == " + std::string(#expected) + indexStream.str(),         \
+                                  actualStream.str(),                                              \
+                                  expectedStream.str(),                                            \
+                                  msgStream.str(),                                                 \
+                                  __FILE__,                                                        \
+                                  __LINE__);                                                       \
+                CONTINUE_ON_FAILURE;                                                               \
+            }                                                                                      \
+            ++i;                                                                                   \
+            ++j;                                                                                   \
+            ++k;                                                                                   \
+        }                                                                                          \
+        if (i != (actual).ConstValuesEnd() || j != (expected).ConstValuesEnd())                    \
+        {                                                                                          \
+            std::ostringstream msgStream;                                                          \
+            msgStream << (msg);                                                                    \
+            std::ostringstream actualStream;                                                       \
+            actualStream << (i != (actual).ConstValuesEnd());                                      \
+            std::ostringstream expectedStream;                                                     \
+            expectedStream << (j != (expected).ConstValuesEnd());                                  \
+            ReportTestFailure("Values::const_iterator == ConstValuesEnd ()",                       \
+                              actualStream.str(),                                                  \
+                              expectedStream.str(),                                                \
+                              msgStream.str(),                                                     \
+                              (__FILE__),                                                          \
+                              (__LINE__));                                                         \
+        }                                                                                          \
+    } while (false);
+
+#endif // SPECTRUM_TEST_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/stats/model/sqlite-output.cc ns-3.46/src/stats/model/sqlite-output.cc
--- ns-3.45/src/stats/model/sqlite-output.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/stats/model/sqlite-output.cc	2025-10-01 18:46:32.000000000 -0700
@@ -22,6 +22,7 @@
 {
     int rc = sqlite3_open(name.c_str(), &m_db);
     NS_ABORT_MSG_UNLESS(rc == SQLITE_OK, "Failed to open DB");
+    sqlite3_busy_timeout(m_db, 100); // set 100 ms timeout for sqlite3 operations
 }
 
 SQLiteOutput::~SQLiteOutput()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/tap-bridge/model/tap-creator.cc ns-3.46/src/tap-bridge/model/tap-creator.cc
--- ns-3.45/src/tap-bridge/model/tap-creator.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/tap-bridge/model/tap-creator.cc	2025-10-01 18:46:32.000000000 -0700
@@ -9,6 +9,7 @@
 #include "ns3/mac48-address.h"
 
 #include <cerrno>
+#include <cstdint>
 #include <cstdlib>
 #include <cstring> // for strerror
 #include <fcntl.h>
@@ -19,7 +20,6 @@
 #include <net/route.h>
 #include <netinet/in.h>
 #include <sstream>
-#include <stdint.h>
 #include <string>
 #include <sys/ioctl.h>
 #include <sys/socket.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/tap-bridge/model/tap-encode-decode.cc ns-3.46/src/tap-bridge/model/tap-encode-decode.cc
--- ns-3.45/src/tap-bridge/model/tap-encode-decode.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/tap-bridge/model/tap-encode-decode.cc	2025-10-01 18:46:32.000000000 -0700
@@ -4,10 +4,10 @@
  * SPDX-License-Identifier: GPL-2.0-only
  */
 
+#include <cstdint>
 #include <iomanip>
 #include <iostream>
 #include <sstream>
-#include <stdint.h>
 #include <string>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/test/CMakeLists.txt ns-3.46/src/test/CMakeLists.txt
--- ns-3.45/src/test/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/test/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -38,6 +38,7 @@
         ns3wifi/wifi-issue-211-test-suite.cc
         ns3wifi/wifi-ac-mapping-test-suite.cc
         ns3wifi/wifi-msdu-aggregator-test-suite.cc
+        # ns3wifi/wifi-mlo-udp-test-suite.cc
     )
   endif()
   if((csma-layout
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/test/traced/traced-callback-typedef-test-suite.cc ns-3.46/src/test/traced/traced-callback-typedef-test-suite.cc
--- ns-3.45/src/test/traced/traced-callback-typedef-test-suite.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/test/traced/traced-callback-typedef-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
@@ -53,6 +53,16 @@
 class TracedCallbackTypedefTestCase : public TestCase
 {
   public:
+    /// @return the TypeId for the callback checkers
+    static TypeId GetCheckerTypeId()
+    {
+        static TypeId tid = TypeId("ns3::TracedCallbackTypedefTestCaseChecker")
+                                .SetParent<Object>()
+                                .SetGroupName("Test")
+                                .HideFromDocumentation();
+        return tid;
+    }
+
     TracedCallbackTypedefTestCase();
 
     ~TracedCallbackTypedefTestCase() override
@@ -268,6 +278,12 @@
     TracedCallback<Ts...> m_cb;
 
   public:
+    /// @return the TypeId for this checker
+    static TypeId GetTypeId()
+    {
+        return TracedCallbackTypedefTestCase::GetCheckerTypeId();
+    }
+
     Checker()
     {
     }
